=== modified file 'rules/convert/java_templates.tpl'
--- old/rules/convert/java_templates.tpl	2022-05-05 17:43:41 +0000
+++ new/rules/convert/java_templates.tpl	2022-05-20 01:25:33 +0000
@@ -7,7 +7,7 @@
 **
 ** Copyright (c) 2004-2022, Golden Code Development Corporation.
 **
-** _#_ _I_ __Date__ __JPRM__ ___________________________________Description___________________________________
+** _#_ _I_ __Date__ __JPRM__ _________________________________ Description__________________________________
 ** 001 GES 20050721   @21760 Good working version which provides many
 **                           templates for processing variable references,
 **                           variable definitions, method calls,
@@ -292,6 +292,10 @@
 **     CA  20220202          alias_buffer_def is no longer deprecated.
 **     CA  20220426          Changed 'class_proxy_client_definition', to allow any kind of procedure, 
 **                           persistent or not.
+**     GES 20220519          Added templates with fewer boolean parameters for temp-table associate() and 
+**                           table-handle createDynamicTable(). Reworked TableParameter templates to allow
+**                           subclasses. Reworked OutputExtentParameter inner class to allow narrowing of
+**                           types.
 */
  -->
  
@@ -1018,6 +1022,40 @@
       </ast>
    </ast-root>
    
+   <!-- inner subclass of an output extent parameter class - in case of variables set as parameter -->
+   <ast-root name="output_extent_var_expr_morph" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
+      <ast id="0" type="ANON_CTOR" text="${extentParamClass}&lt;${rettype}&gt;">
+         <ast id="0" type="CS_INSTANCE_METHODS" text="">
+            <ast id="0" type="METHOD_DEF" text="getVariable">
+               <annotation datatype="java.lang.String" key="access" value="public" />
+               <annotation datatype="java.lang.String" key="rettype" value="${rettype}[]" />
+               <ast id="0" type="BLOCK" text="block">
+                  <ast id="0" type="KW_RETURN" text="">
+                     <ast id="0" type="STATIC_METHOD_CALL" text="${narrow}">
+                        <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
+                     </ast>
+                  </ast>
+               </ast>
+            </ast>
+            <ast id="0" type="METHOD_DEF" text="setVariable">
+               <annotation datatype="java.lang.String" key="access" value="public" />
+               <annotation datatype="java.lang.String" key="rettype" value="void" />
+               <ast col="0" id="0" line="0" text="" type="LPARENS">
+                  <ast col="0" id="0" line="0" text="${rettype}[]" type="REFERENCE_DEF">
+                     <annotation datatype="java.lang.Boolean" key="final" value="true" />
+                     <annotation datatype="java.lang.String" key="name" value="newRef" />
+                  </ast>
+               </ast>
+               <ast id="0" type="BLOCK" text="block">
+                  <ast id="0" type="ASSIGN" text="=">
+                     <ast col="0" id="0" line="0" text="${widen}newRef)" type="REFERENCE" />
+                  </ast>
+               </ast>
+            </ast>
+         </ast>
+      </ast>
+   </ast-root>   
+   
    <!-- inner subclass of a resolvable expression class -->
    <ast-root name="anon_expr" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
       <ast id="0" type="ANON_CTOR" text="${classname}">
@@ -1337,13 +1375,13 @@
 
    <!-- instantiate a TableParameter -->
    <ast-root name="table_param" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
-      <ast id="0" type="CONSTRUCTOR" text="TableParameter">
+      <ast id="0" type="CONSTRUCTOR" text="${tab-parm-type}">
          <ast id="0" type="REFERENCE" text="${javaname}" />
       </ast>
    </ast-root>
 
    <ast-root name="table_param_static" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
-      <ast id="0" type="CONSTRUCTOR" text="TableParameter">
+      <ast id="0" type="CONSTRUCTOR" text="${tab-parm-type}">
          <ast id="0" type="METHOD_CALL" text="get">
             <ast id="0" type="REFERENCE" text="${javaname}" />
          </ast>
@@ -2148,8 +2186,6 @@
       <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.associate">
          <ast id="0" type="REFERENCE" text="${javaname1}" />
          <ast id="0" type="REFERENCE" text="${javaname2}" />
-         <ast id="0" type="${input}" text="" />
-         <ast id="0" type="${output}" text="" />
       </ast>
    </ast-root>
 
@@ -2158,6 +2194,24 @@
       <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.createDynamicTable">
          <ast id="0" type="REFERENCE" text="${javaname1}" />
          <ast id="0" type="REFERENCE" text="${javaname2}" />
+      </ast>
+   </ast-root>
+   
+   <!-- set up an association between two temp table instances -->
+   <ast-root name="associate_temp_tables_full" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
+      <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.associate">
+         <ast id="0" type="REFERENCE" text="${javaname1}" />
+         <ast id="0" type="REFERENCE" text="${javaname2}" />
+         <ast id="0" type="${input}" text="" />
+         <ast id="0" type="${output}" text="" />
+      </ast>
+   </ast-root>
+
+   <!-- create dynamic temp table -->
+   <ast-root name="create_dynamic_tt_full" terse="true" ast_class="com.goldencode.p2j.uast.JavaAst" >
+      <ast id="0" type="STATIC_METHOD_CALL" text="TemporaryBuffer.createDynamicTable">
+         <ast id="0" type="REFERENCE" text="${javaname1}" />
+         <ast id="0" type="REFERENCE" text="${javaname2}" />
          <ast id="0" type="${input}" text="" />
          <ast id="0" type="${output}" text="" />
       </ast>

=== modified file 'rules/convert/output_parameters.rules'
--- old/rules/convert/output_parameters.rules	2021-06-09 14:35:48 +0000
+++ new/rules/convert/output_parameters.rules	2022-05-20 02:09:03 +0000
@@ -5,7 +5,7 @@
 ** Module   : output_parameters.rules
 ** Abstract : procedure/function output and input-output parameters analysis
 **
-** Copyright (c) 2013-2021, Golden Code Development Corporation.
+** Copyright (c) 2013-2022, Golden Code Development Corporation.
 **
 ** _#_ _I_ __Date__ _________________________________Description__________________________________
 ** 001 CA  20130208 Created initial version.
@@ -27,8 +27,10 @@
 **     CA  20210216 Fix for the 'cast-to-object' case for a single extent argument in a dynamic call, when
 **                  INPUT modifier exists or not.
 **     CA  20210609 Fixed extent property used as output/input-output argument.
+**     GES 20220519 Reworked OutputExtentParameter to morph types for OO method usage when the types narrow.
 */
  -->
+ 
 <!--
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU Affero General Public License as
@@ -93,19 +95,27 @@
    <include name="common-progress" />
    
    <!-- variables -->   
-   <variable name="propref"  type="com.goldencode.ast.Aast" />
-   <variable name="ref"      type="com.goldencode.ast.Aast" />
-   <variable name="chref"    type="com.goldencode.ast.Aast" />
-   <variable name="varref"   type="com.goldencode.ast.Aast" />
-   <variable name="wrapper"  type="java.lang.String" />
-   <variable name="rettype"  type="java.lang.String" />
-   <variable name="template" type="java.lang.String" />
+   <variable name="propref"          type="com.goldencode.ast.Aast" />
+   <variable name="ref"              type="com.goldencode.ast.Aast" />
+   <variable name="chref"            type="com.goldencode.ast.Aast" />
+   <variable name="varref"           type="com.goldencode.ast.Aast" />
+   <variable name="wrapper"          type="java.lang.String" />
+   <variable name="rettype"          type="java.lang.String" />
+   <variable name="calltype"         type="java.lang.String" />
+   <variable name="narrow"           type="java.lang.String" />
+   <variable name="widen"            type="java.lang.String" />
+   <variable name="template"         type="java.lang.String" />
    <variable name="extentParamClass" type="java.lang.String" />
    
    <walk-rules>
       
       <rule>isNote("outputExtentType")
          <action>rettype = getNoteString("outputExtentType")</action>
+         
+         <rule>isNote("calltype")
+            <action>calltype = getNoteString("calltype")</action>
+            <action on="false">calltype = rettype</action>
+         </rule>
 
          <!-- handle extent variables/fields set at function/procedure calls -->
          <rule>!evalLib("fields")
@@ -120,15 +130,29 @@
                   extentParamClass = "InputOutputExtentParameter"
                </action>
             </rule>
+            
             <!-- emit the inner class -->
-            <action>
-               tw.graft("output_extent_var_expr", copy,
-                        closestPeerId,
-                        "rettype", rettype,
-                        "extent", sprintf("%d", getNoteLong("extent")),
-                        "extentParamClass", extentParamClass)
-            </action>
-
+            <rule>!rettype.equals(calltype)
+               <action>narrow = execLib("type_conversion_method_name", rettype)</action>
+               <action>widen = sprintf("%s(", execLib("type_conversion_method_name", calltype))</action>
+               <action>
+                  tw.graft("output_extent_var_expr_morph", copy,
+                           closestPeerId,
+                           "rettype", rettype,
+                           "narrow", narrow,
+                           "widen", widen,
+                           "extent", sprintf("%d", getNoteLong("extent")),
+                           "extentParamClass", extentParamClass)
+               </action>
+               <action on="false">
+                  tw.graft("output_extent_var_expr", copy,
+                           closestPeerId,
+                           "rettype", rettype,
+                           "extent", sprintf("%d", getNoteLong("extent")),
+                           "extentParamClass", extentParamClass)
+               </action>
+            </rule>
+            
             <!-- for fields, we emit the dedicated handler 
                  decide the class depending on parameter type -->
             <rule on="false">getNoteLong("parmtype") == prog.kw_output

=== modified file 'rules/convert/variable_definitions.rules'
--- old/rules/convert/variable_definitions.rules	2021-07-26 12:52:17 +0000
+++ new/rules/convert/variable_definitions.rules	2022-05-12 15:03:49 +0000
@@ -7,7 +7,7 @@
 **
 ** Copyright (c) 2005-2021, Golden Code Development Corporation.
 **
-** _#_ _I_ __Date__ __JPRM__ ____________________________Description_____________________________
+** _#_ _I_ __Date__ __JPRM__ __________________________________Description___________________________________
 ** 001 GES 20050727   @21865 First version which converts Progress
 **                           variable definitions into Java instance or
 **                           local variable definitions.  Procedure and
@@ -218,6 +218,8 @@
 **     CA  20210726          Fixed a bug when external program's extent parameters are promoted to class 
 **                           fields: those fields must be two-dimension, too, if the parameter is 'extent
 **                           mutable'.
+**     GES 20210506          Reworked table-handle and dataset-handle parameters to use subclasses of
+**                           TableParameter/DataSetParameter.
 */
  -->
 
@@ -347,6 +349,7 @@
    <variable name="typeSuffix" type="java.lang.String" />
    <variable name="parMode"    type="java.lang.String" />
    <variable name="aliases"    type="java.lang.String" />
+   <variable name="jtype"      type="java.lang.String" />
    <variable name="mode"       type="java.lang.Integer" />
    <variable name="initparm"   type="java.lang.Boolean" />
    <variable name="global"     type="java.lang.Boolean" />
@@ -504,7 +507,6 @@
             !evalLib("is_schema_trigger_new_value")                              and
             !evalLib("is_schema_trigger_old_value")                              and
             !(this.type == prog.parameter and ancestor(prog.event_signature, 2)) and
-            !(this.type == prog.define_property and (isAbstract or isIface))     and
             this.type != prog.define_dataset                                     and
             this.type != prog.define_data_source                                 and
             !(this.type == prog.define_property and (isAbstract or isIface))     and
@@ -768,17 +770,33 @@
          </rule>
          
          <!-- now create a REFERENCE_DEF as the first child of the ASSIGN such that the classname
-              and the variable's Java name will be emitted; 
-              if is a TABLE-HANDLE parameter of a procedure, use TableParameter; in case of a
-              DATASET-HANDLE use DataSetParameter. -->
+              and the variable's Java name will be emitted -->
          <rule>descendant(prog.kw_tab_hand, 1)
-            <action>
-               refid = createJavaAst(java.reference_def, "TableParameter", lastid)
+         
+            <!-- lookup the TableParameter subclass that should be used, use the base class for
+                 functions or procedures (but we must use a subclass for OO methods) -->
+            <action>
+               jtype = execLib("read_jtype",
+                               copy.getImmediateChild(prog.kw_tab_hand, null),
+                               "TableParameter",
+                               "var defs 1")
+            </action>
+            <action>
+               refid = createJavaAst(java.reference_def, jtype, lastid)
             </action>
             
             <rule on="false">descendant(prog.kw_dset_hnd, 1)
-               <action>
-                  refid = createJavaAst(java.reference_def, "DataSetParameter", lastid)
+            
+               <!-- lookup the DataSetParameter subclass that should be used, use the base class for
+                    functions or procedures (but we must use a subclass for OO methods) -->
+               <action>
+                  jtype = execLib("read_jtype",
+                                  copy.getImmediateChild(prog.kw_dset_hnd, null),
+                                  "DataSetParameter",
+                                  "var defs 2")
+               </action>
+               <action>
+                  refid = createJavaAst(java.reference_def, jtype, lastid)
                </action>
                
                <!-- do not emit OLD/NEW var from ASSIGN trigger; it was promoted and will be

=== modified file 'rules/convert/variable_references.rules'
--- old/rules/convert/variable_references.rules	2022-05-16 16:24:45 +0000
+++ new/rules/convert/variable_references.rules	2022-05-20 12:08:54 +0000
@@ -7,7 +7,7 @@
 **
 ** Copyright (c) 2005-2022, Golden Code Development Corporation.
 **
-** _#_ _I_ __Date__ __JPRM__ ____________________________Description_____________________________
+** _#_ _I_ __Date__ __JPRM__ __________________________________Description___________________________________
 ** 001 GES 20050727   @21866 First version which converts Progress variable references (including
 **                           array subscripts) into Java instance or local variable references.
 **                           All built-in functions  that truly act as global variables are
@@ -161,6 +161,7 @@
 **                           can have the INPUT/OUTPUT/INPUT-OUTPUT modes set.
 **     CA  20220516          Added conversion for COMPILER. 
 **     CA  20220516          Fixes related to an indexed OO property access, which is chained with a reference.
+**     GES 20210519          Reworked table-handles to use subclasses of TableParameter.
 */
  -->
  
@@ -266,31 +267,33 @@
    </func-library>
    
    <!-- variables -->
-   <variable name="lastid"       type="java.lang.Long" />
-   <variable name="newid"        type="java.lang.Long" />
-   <variable name="subid"        type="java.lang.Long" />
-   <variable name="refid"        type="java.lang.Long" />
-   <variable name="methodType"   type="java.lang.Integer" />
-   <variable name="oldtype"      type="java.lang.Integer" />
-   <variable name="idx"          type="java.lang.Integer" />
-   <variable name="propBypass"   type="java.lang.Boolean" />
-   <variable name="needsRef"     type="java.lang.Boolean" />
-   <variable name="dbimport"     type="java.lang.Boolean" />
-   <variable name="uiimport"     type="java.lang.Boolean" />
-   <variable name="pmimport"     type="java.lang.Boolean" />
-   <variable name="keyimport"    type="java.lang.Boolean" />
-   <variable name="ltimport"     type="java.lang.Boolean" />
-   <variable name="smimport"     type="java.lang.Boolean" />
-   <variable name="aaimport"     type="java.lang.Boolean" />
-   <variable name="mathimport"   type="java.lang.Boolean" />
-   <variable name="methodTxt"    type="java.lang.String" />
-   <variable name="clsname"      type="java.lang.String" />
-   <variable name="chp_wrapper"  type="java.lang.String" />
-   <variable name="ref"          type="com.goldencode.ast.Aast" />
-   <variable name="ref2"         type="com.goldencode.ast.Aast" />
-   <variable name="varref"       type="com.goldencode.ast.Aast" />
-   <variable name="subref"       type="com.goldencode.ast.Aast" />
-   <variable name="wrapimp"      type="java.lang.Boolean" /> <!-- static OutputParameter -->
+   <variable name="lastid"         type="java.lang.Long" />
+   <variable name="newid"          type="java.lang.Long" />
+   <variable name="subid"          type="java.lang.Long" />
+   <variable name="refid"          type="java.lang.Long" />
+   <variable name="methodType"     type="java.lang.Integer" />
+   <variable name="oldtype"        type="java.lang.Integer" />
+   <variable name="idx"            type="java.lang.Integer" />
+   <variable name="propBypass"     type="java.lang.Boolean" />
+   <variable name="needsRef"       type="java.lang.Boolean" />
+   <variable name="dbimport"       type="java.lang.Boolean" />
+   <variable name="uiimport"       type="java.lang.Boolean" />
+   <variable name="pmimport"       type="java.lang.Boolean" />
+   <variable name="keyimport"      type="java.lang.Boolean" />
+   <variable name="ltimport"       type="java.lang.Boolean" />
+   <variable name="smimport"       type="java.lang.Boolean" />
+   <variable name="aaimport"       type="java.lang.Boolean" />
+   <variable name="mathimport"     type="java.lang.Boolean" />
+   <variable name="methodTxt"      type="java.lang.String" />
+   <variable name="clsname"        type="java.lang.String" />
+   <variable name="chp_wrapper"    type="java.lang.String" />
+   <variable name="cname"          type="java.lang.String" />
+   <variable name="tabParmType"    type="java.lang.String" />
+   <variable name="ref"            type="com.goldencode.ast.Aast" />
+   <variable name="ref2"           type="com.goldencode.ast.Aast" />
+   <variable name="varref"         type="com.goldencode.ast.Aast" />
+   <variable name="subref"         type="com.goldencode.ast.Aast" />
+   <variable name="wrapimp"        type="java.lang.Boolean" /> <!-- static OutputParameter -->
    
    <!-- main processing (once per tree) -->
    <init-rules>
@@ -572,18 +575,21 @@
                      <action>
                         lastid = createPeerAst(java.constructor, "PropertyReference", closestPeerId)
                      </action>
-
+                  
                      <rule on="false">isNote("assign_back")
                         <action>
                            lastid = createPeerAst(java.static_method_call, "wrap", closestPeerId)
                         </action>
                         <action>wrapimp = true</action>
                         
-                        <action>
-                           createJavaAst(java.reference, 
-                                         sprintf("%s.class", ref.getAnnotation("classname")), 
-                                         lastid)
-                        </action>
+                        <action>cname = ref.getAnnotation("classname")</action>
+                        <rule>cname.startsWith("object&lt;")
+                           <action>cname = "object"</action>
+                        </rule>
+                        <rule>cname.startsWith("jobject&lt;")
+                           <action>cname = "jobject"</action>
+                        </rule>
+                        <action>createJavaAst(java.reference, sprintf("%s.class", cname), lastid)</action>
                         
                         <rule>getNoteBoolean("needs_value")
                            <action>copy.putAnnotation("wrapNodeId", lastid)</action>
@@ -669,11 +675,16 @@
                </rule>
                
                <rule>isNote("classname")
-                  <action>
-                     createJavaAst(java.reference, 
-                                   sprintf("%s.class", getNoteString("classname")), 
-                                   lastid)
-                  </action>
+               
+                  <action>cname = getNoteString("classname")</action>
+                  <rule>cname.startsWith("object&lt;")
+                     <action>cname = "object"</action>
+                  </rule>
+                  <rule>cname.startsWith("jobject&lt;")
+                     <action>cname = "jobject"</action>
+                  </rule>
+                  <action>createJavaAst(java.reference, sprintf("%s.class", cname), lastid)</action>
+                  
                </rule>
                <action>wrapimp = true</action>
                
@@ -908,15 +919,25 @@
          <!-- create the node -->
          <rule>methodTxt != null
             <rule>relativePath("KW_TAB_HAND/VAR_HANDLE")
-               
+                                              
+               <!-- lookup the TableParameter subclass that should be used, use the base class for
+                    functions or procedures (but we must use a subclass for OO methods) -->
+               <action>
+                  tabParmType = execLib("read_jtype", copy.parent, "TableParameter", "var refs")
+               </action>
+            
                <!-- case of TABLE-HANDLE parameter passed to a function -->
                <action>ref = getAst(getNoteLong("refid"))</action>
                <rule>ref.isAnnotation("static") and getReferenceNoteBoolean(ref.id, "static")
                   <action>
-                     ref = tw.graft("table_param_static", copy, closestPeerId, "javaname", methodTxt)
+                     ref = tw.graft("table_param_static", copy, closestPeerId,
+                                    "tab-parm-type", tabParmType,
+                                    "javaname", methodTxt)
                   </action>
                   <action on="false">
-                     ref = tw.graft("table_param", copy, closestPeerId, "javaname", methodTxt)
+                     ref = tw.graft("table_param", copy, closestPeerId,
+                                    "tab-parm-type", tabParmType,
+                                    "javaname", methodTxt)
                   </action>
                </rule>
                

=== modified file 'rules/include/common-progress.rules'
--- old/rules/include/common-progress.rules	2022-05-16 12:34:34 +0000
+++ new/rules/include/common-progress.rules	2022-05-23 19:11:40 +0000
@@ -470,6 +470,8 @@
 **                           distinguish the parameter in a ParameterList:setParameter, as this OO method call
 **                           can have the INPUT/OUTPUT/INPUT-OUTPUT modes set.
 **     CA  20220516          Added 'getUniqueJavaMethodName', moved from annotations.xml.
+**     GES 20210506          Added read_jtype. Reworked enum_java_type to use ClassDefinition.  Added
+**                           type_conversion_method_name and is_unsubscripted_extent.
 */
  -->
  
@@ -1056,6 +1058,38 @@
          <rule>mixed = (numd &gt; 0 and numf != numd)</rule>
       </function>
       
+      <function name="type_conversion_method_name">
+         <parameter    name="classname" type="java.lang.String" />
+         <return       name="methname"  type="java.lang.String" />
+         
+         <rule>methname = ""</rule>
+         
+         <rule>classname.equals("integer")
+            <action>methname = "toInteger"</action>
+         </rule>
+         <rule>classname.equals("int64")
+            <action>methname = "toInt64"</action>
+         </rule>
+         <rule>classname.equals("decimal")
+            <action>methname = "toDecimal"</action>
+         </rule>
+         <rule>classname.equals("date")
+            <action>methname = "toDate"</action>
+         </rule>
+         <rule>classname.equals("datetime")
+            <action>methname = "toDatetime"</action>
+         </rule>
+         <rule>classname.equals("datetimetz")
+            <action>methname = "toDatetimeTz"</action>
+         </rule>
+         <rule>classname.equals("character")
+            <action>methname = "toCharacter"</action>
+         </rule>
+         <rule>classname.equals("longchar")
+            <action>methname = "toLongchar"</action>
+         </rule>
+      </function>
+      
       <function name="wrapper_name_for_field_type">
          <parameter name="ttype"     type="java.lang.Integer" />
          <return    name="classname" type="java.lang.String" />
@@ -3299,7 +3333,7 @@
          <parameter name="target"  type="com.goldencode.ast.Aast" />
          <variable  name="cname"   type="java.lang.String" />
          <variable  name="qname"   type="java.lang.String" />
-         <variable  name="ccn"     type="com.goldencode.p2j.uast.ConvertedClassName" />
+         <variable  name="cdef"    type="com.goldencode.p2j.uast.ClassDefinition" />
          <return    name="jname"   type="java.lang.String" />
          
          <rule>cname = ecw.expressionType(target)</rule>
@@ -3307,8 +3341,8 @@
          <rule>cname != null
             <rule>cname.startsWith("object&lt;? extends ")
                <action>qname = cname.substring(17, cname.length() - 1)</action>
-               <action>ccn = loadConvertedClassByQname(qname)</action>
-               <action>jname = sprintf("object&lt;? extends %s&gt;", ccn.getQualifiedName())</action>
+               <action>cdef = loadConvertedClassByQname(qname)</action>
+               <action>jname = sprintf("object&lt;? extends %s&gt;", cdef.getQualifiedName())</action>
             </rule>
          </rule>
       </function>
@@ -6481,6 +6515,22 @@
          
       </function>
       
+      <function name="is_unsubscripted_extent">
+         <parameter name="target"   type="com.goldencode.ast.Aast" />
+         <return    name="isExtent" type="java.lang.Boolean" />
+         <variable  name="extent"   type="java.lang.Long" />
+         
+         <rule>isExtent = false</rule>
+         
+         <rule>target.isAnnotation("extent")
+            <rule>extent = target.getAnnotation("extent")</rule>
+            <rule>
+               isExtent = (extent == -1 or extent &gt; 0) and !target.descendant(1, prog.lbracket)
+            </rule>
+         </rule>
+         
+      </function>
+      
       <function name="get_function_return_class">
          <parameter name="target" type="com.goldencode.ast.Aast" />
          <variable  name="ttype"  type="java.lang.Integer" />
@@ -10817,6 +10867,28 @@
          </rule>
       </function>
       
+      <function name="read_jtype">
+         <parameter  name="node"    type="com.goldencode.ast.Aast" />
+         <parameter  name="defval"  type="java.lang.String" />
+         <parameter  name="descr"   type="java.lang.String" />
+         <variable   name="ref"     type="com.goldencode.ast.Aast" />
+         <return     name="jtype"   type="java.lang.String" />
+         
+         <rule>jtype = defval</rule>
+         
+         <rule>!node.isAnnotation("jtype") and node.parent.isAnnotation("jtype")
+            <action>ref = node.parent</action>
+            <action on="false">ref = node</action>
+         </rule>
+         
+         <rule>ref.isAnnotation("jtype") 
+            <action>jtype = #(java.lang.String) ref.getAnnotation("jtype")</action>
+            <action on="false">
+               printf("WARNING: missing 'jtype' annotation for %s at %s\n", descr, ref.dumpTree())
+            </action>
+         </rule>
+      </function>
+      
       <!-- Create a runtime annotation.
          When executed in runtime mode, any object can be stored as annotation because they are
             kept in a memory persistence, not serialized to disk.

